﻿Type=Class
Version=6.31
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
' =======================================================================================
' Description ...: Form Generator
' Requirement(s).: Basic4Android 6.31
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.5.2.0
' Date...........: 12 April 2017
' License........: Free to use without any warranties
' =======================================================================================
'Class module
Sub Class_Globals
	Dim fh_Data As Map = CreateMap()		' Reference to widget of data
	Dim fh_FieldsType As Map = CreateMap()		' Reference to fields type
	Dim numericTypes As Map = CreateMap("N":True,"DN":True,"S":True)	' widgets with numeric values
	Dim comparator As Map = CreateMap("=":1,">":2,"<":4,">=":3,"<=":5,"<>":6)
	Dim fh_yesToExit As Boolean = True	' used for block exit 
	Private fh_returnSub() As String	' Module and sub
	Private fh_handleSub() As String	' Module and sub for handle events
	Private fh_panel As ScrollView	' Reference to panel handle
	Dim widgetRef As Map	' Reference to widget of data
	Private Elem As Map		' data fields
	Private Defaults As Map	' fields defaults
	Dim tipsMap As Map		' tooltips Map, key is field name
	Private checks As Map	' checks on wiew, key is field name
	Private required As Map	' required wiews, key is field name
	Private after As Map = CreateMap("fh_":"")	' after key is view to set after value
	Dim nElem As Int		' Elements number	
	Dim Limits As Map		' for numerics fields
	Dim mapValues As Map	' combo/radio key value
	Dim hiddensMap As Map	' Hiddens values
	Dim field() As String
	Dim wWidget As Int		' maximum widget width
	Dim pnl As Panel
	Dim lbl As Label
	Dim lblTitle As Label
	Dim btn As Button
	Dim InputBox As EditText
	Dim Matcher1 As Matcher
	Dim Sections(1,3) As String		' sections array
	Dim Section As Int = -1			' actual section
	Dim act As Activity
'	Dim VR As VoiceRecognition
'	VR.Initialize("VR")
	Private focusedText As EditText
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
End Sub
Sub fg(activ As Activity,params As String,retSub As String,handleSub As String) As String()
	fh_returnSub = Regex.Split("\.",retSub)		' split module and sub
	fh_handleSub = Regex.Split("\.",handleSub)	' split module and sub
	act = activ
	Dim prefix As String = ""
	If Not(Regex.IsMatch2("^\s*section.*",Regex.CASE_INSENSITIVE,params)) Then prefix = "Section,fh_section;"
	Dim s() As String = Regex.split2("^section,|;\s*section,",Regex.CASE_INSENSITIVE,prefix & params)
	Dim Sections(s.Length-1,3) As String
	For i = 1 To s.Length -1
		Matcher1 = Regex.Matcher("(.*?);(.*)",s(i))
		If Matcher1.Find Then
			Dim sectorParm() As String = Regex.Split(",",Matcher1.Group(1))	' force three fields
			Sections(i-1,0) = Matcher1.Group(2)
			Sections(i-1,1) = sectorParm(0)		' section name
			Sections(i-1,2) = implodeFrom(",",sectorParm,1,sectorParm.Length-1)			' check conditions
		End If
	Next
	fh_Data.Clear
	fh_FieldsType.Clear
	CallSubDelayed2("","fh_answer",fh_Data)
End Sub
Sub fh_answer(Data As Map)
	Dim button As String = Data.GetDefault("fh_button","First stroke")
	If button = "Cancel" Then
		CallSubDelayed2(fh_returnSub(0),fh_returnSub(1),CreateMap("fh_button":"Cancel"))
		Section = -1
	Else
		If button = "fh_Back" Then
			Section = Section - 1
		Else
			Section = Section + 1
		End If	
		If Section >= Sections.Length Then
			Section = -1
			CallSubDelayed2(fh_returnSub(0),fh_returnSub(1),Data)
		Else
			' check if section is conditioned
			Dim conditions() As String = Regex.Split(",",Sections(Section,2))
			Dim condition As Boolean = True
			For i = 0 To conditions.Length - 1
				If conditions(i) <> "" Then
					Matcher1 = Regex.Matcher("(.+?)\s*(=|<=|>=|<>|>|<)\s*(.*)",conditions(i))
					If Not(Matcher1.Find) Then Continue
					Dim fieldName As String = Matcher1.Group(1)
					Dim operand As String = deMask(Matcher1.Group(3))
					Dim operator As String = Matcher1.Group(2)
					If Not(compare(numericTypes.GetDefault(fh_FieldsType.GetDefault(fieldName,False),False),fh_Data.GetDefault(fieldName,""),operator,operand)) Then 
						condition = False
					End If
				End If
			Next
			If condition Then
				lblTitle.Initialize("")
				lblTitle.TextSize = 20
				lblTitle.Typeface = Typeface.DEFAULT_BOLD
				lblTitle.text = "Section " & Sections(Section,1)
				lblTitle.Gravity = Gravity.CENTER
				Dim buttons As String = ""
				If Sections.Length > 1 Then
					If Section > 0 Then buttons = ";B,fh_Back,<--"
					If Section < Sections.Length -1 Then buttons = buttons & ";B,Ok,-->"
				End If
				CallSubDelayed2("","fgSection",Sections(Section,0) & buttons)
			Else
				CallSubDelayed2("","fgSection","")	' this because there is not goto
			End If
		End If
	End If
End Sub
Sub fgSection(params As String)
	If params = "" Then
		CallSubDelayed2("","fh_answer",fh_Data)
		Return
	End If
	widgetRef.Initialize
	Elem.Initialize
	tipsMap.Initialize
	checks.Initialize
	required.Initialize
	Limits.Initialize
	mapValues.Initialize
	Defaults.Initialize
	hiddensMap.Initialize
	Dim cmb As Spinner
	Dim rdb As RadioButton
	Dim widgets() As String	
	Dim dummy,width, btnWidth,offsetX, offsetBtn, offsetY,deltaY As Int
	Dim charWidth As Int = 12	
	Dim finalButtons As String ,wdgType As String
	Dim standardButtons As Map = CreateMap("Ok":"Ok","Cancel":"Cancel","Reset":"Reset")
	Dim fromTo() As String	' array for limits (used also for ground colors and defaults)
	Dim typeForm As String	' typeForm: T = text, B = buttons, C = combo box (spinner)
	offsetX = 5%x
	offsetY = 40dip
	width = 50dip
	btnWidth = 65dip
	deltaY = 36dip
	widgets = Regex.Split(";\s*", "Ground;" & params)	' for default
	fh_panel.Initialize(100%y)
	fh_panel.Tag = "fh_panel"
	Dim c As Canvas
	c.Initialize(act)
	Dim dimLabels As Int = 0
	' normalize request: control and clean parameters
For iw = 0 To widgets.Length - 1
	If Left(widgets(iw),1) = "'" Or widgets(iw) = "" Then Continue	' comment
	field = Regex.Split(",", widgets(iw) & ",,,,,,*")
	field(field.Length-1) = ""	' remove *
	field(0) = field(0).ToUpperCase	' upper case
	If field(0) = "TITLE" Then		' title
		lblTitle.text = field(2)
		If field(3) <> "" Then lblTitle.Color = decodeColor(field(3))	' background title
		widgetRef.Put(field(1),Array As Object (lblTitle,"TITLE"))
	Else if field(0) = "DEFAULTS" Then		' defaults view
		For ir=1 To field.Length - 1
			If field(ir) <> "" Then
				fromTo = Regex.split("\s*:",field(ir) & ":")
				If fromTo.Length = 2 Then Defaults.Put(fromTo(0),fromTo(1))
			End If
		Next
	Else if field(0) = "REQUIRED" Then							' required view
		For ir=1 To field.Length - 1
			required.Put(field(ir),"")
		Next
	Else If field(0) = "TIP" Then		' tool tip
		tipsMap.Put(field(1),field(2))
	Else If field(0) = "H" Or field(0) = "HIDDEN" Then			' Hiddens fields
		hiddensMap.Put(field(1),field(2))
	Else If field(0) = "CHECK" Then		' checks on fields
		Matcher1 = Regex.Matcher2("(.+?)\s*(=|<=|>=|<>|>|<|is)\s*.*",Regex.CASE_INSENSITIVE,field(1))
		If Matcher1.Find Then
			addCheck(Matcher1.Group(1),Array As String(field(1),field(2)))		' check and possible error message
		End If		
	Else If field(0) = "AFTER" Then		' after
		after.Put(field(1),field(2))
	Else If field(0) = "BACKGROUND" Or field(0) = "GROUND" Then	' Background
		Dim grad As GradientDrawable
		Dim cols(2) As Int		
		If field(1) = "" Then field(1) = "FF404040 FF404040"
		fromTo = Regex.split("[ ]+",field(1))
		If fromTo.Length = 1 Then field(1) = field(1) & " " & field(1) & " TOP_BOTTOM"
		If fromTo.Length = 2 Then field(1) = field(1) & " TOP_BOTTOM"
		Dim prms(3) As String = Regex.split("[ ]+",field(1))
		cols(0) = decodeColor(Left("FF000000",8-prms(0).Length) & prms(0))
		cols(1) = decodeColor(Left("FF000000",8-prms(1).Length) & prms(1))
		grad.Initialize(prms(2),cols)
		fh_panel.Panel.Background = grad
	Else		
		If field(2) = "" Then field(2) = field(1)	' if there is not label
		field(2) = deMask(field(2))
		If field(3) = "" Then field(3) = Max(20,field(4).Length)	' length widget
		If field(0) = "" Then field(0) = "T"
		If Not(Defaults.ContainsKey(field(1))) Then Defaults.Put(field(1),field(4))	' set defaults map
		If field(0) = "B" And standardButtons.ContainsKey(field(1)) Then 
			standardButtons.Put(field(1),field(2))	'change description of standard buttons			
			Continue
		End If
		If field(0) = "S" Then
				If field(5) = "" Then field(5) = "0 100"	' default slide
				fromTo = Regex.split(" ",field(5))
				Limits.Put(field(1) & "Min",fromTo(0))
				Limits.Put(field(1) & "Max", 100)
				If fromTo.Length = 2 Then Limits.Put(field(1) & "Max",fromTo(1))
				Limits.Put(field(1) & "Delta", Abs(Limits.get(field(1) & "Max") - Limits.get(field(1) & "Min")))				
		End If
		field(4) = deMask(field(4).Trim())
		field(5) = deMask(field(5))
		dummy = c.MeasureStringWidth(field(2),Typeface.DEFAULT,12)
		If dummy > dimLabels Then dimLabels = dummy
		Elem.Put(field(1),field)
		fh_FieldsType.Put(field(1),field(0))	' for type numeric or string
'		If Not(Defaults.ContainsKey(field(1))) Then Defaults.Put(field(1),field(4))	' set defaults map
	End If
Next
	nElem = Elem.Size
	' compute maximum widget width
	wWidget = (100%x -2 * offsetX -5dip -dimLabels) / charWidth
	Dim btns() As String		'
'	Dim Buttons(32) As Button	' event handler
	typeForm = ""				' for type of final buttons
' create form -------------------------------------------------------------------------------------
	fh_panel.Panel.AddView(lblTitle,0 , 0, 100%x, 30dip)
For i = 0 To nElem - 1
	lbl.Initialize("")
	field = Elem.GetValueAt(i)
	lbl.TextSize = 12
	lbl.text = field(2)
	wdgType = field(0)
	Dim txtProto As EditText
	If wdgType = "B" Or  wdgType = "BC" Then
		btn.Initialize("buttons")
		If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
			Dim afterView As View = getFromViewMap(after.Get(field(1)),0)
			btn.TextSize = 12
			btn.Text = field(2)
			btn.Tag = field(1)
			fh_panel.Panel.AddView(btn,afterView.Left+afterView.Width+10, afterView.Top , field(3) * charWidth, deltaY-2dip)
		Else		
			finalButtons = finalButtons & field(1) & ":" & field(2) & ","
		End If		
		widgetRef.Put(field(1),Array As Object (btn,wdgType,0,field(5)))	' changed after
	Else If wdgType = "CKB" Then
		Dim ckbProto As CheckBox
		ckbProto.Initialize("checkBox")
		ckbProto.TextSize = 12
		ckbProto.text = " " & field(5)
		ckbProto.Tag = field(1)
		If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
			Dim afterView As View = getFromViewMap(after.Get(field(1)),0)			
			fh_panel.Panel.AddView(ckbProto,afterView.Left+afterView.Width+10, afterView.Top , field(3) * charWidth, deltaY-2dip)
		Else
			fh_panel.Panel.AddView(ckbProto ,offsetX+5dip + dimLabels ,  offsetY , field(3) * charWidth, deltaY-2dip)
		End If
		widgetRef.Put(field(1),Array As Object (ckbProto,wdgType,lbl))
	Else If wdgType = "R" Then			' *** Radiobuttons
		Dim rdbList As List,j As Int
		rdbList = splitKeyValue(field(1),field(5))
		pnl.Initialize("")
		widgetRef.Put(field(1),Array As Object (pnl,wdgType,lbl,0))
		For j = 0 To rdbList.Size-1
			rdb.Initialize("RadioButton")
			rdb.TextSize = 12
			rdb.text = rdbList.get(j)
			rdb.Tag = field(1)
			pnl.AddView(rdb,j*field(3) * charWidth,0,field(3) * charWidth, deltaY-2dip)
			If rdbList.get(j) = field(4) Then widgetRef.Put(field(1),Array As Object (pnl,wdgType,lbl,rdb))	' default
		Next
		If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
			Dim afterView As View = getFromViewMap(after.Get(field(1)),0)			
			fh_panel.Panel.AddView(pnl,afterView.Left+afterView.Width+10, afterView.Top , field(3) * charWidth, deltaY-2dip)
		Else
			fh_panel.Panel.AddView(pnl,offsetX+5dip + dimLabels, offsetY , field(3) * charWidth, deltaY-2dip)
		End If
		pnl.width = 90%x
	Else If wdgType = "CMB" Or wdgType = "CMX"  Or wdgType = "F" Then		' *** ComboBox (spinner) and File
		cmb.Initialize("combos") 'All combos share the same event sub
		cmb.TextSize = 12
		fh_panel.Panel.AddView(cmb,offsetX+5dip + dimLabels , offsetY , Min(field(3),20) * charWidth, deltaY-2dip)
		cmb.Tag = field(1)
		If wdgType <> "F" Then
			cmb.addall(splitKeyValue(field(1),field(5)))
		End If
		widgetRef.Put(field(1),Array As Object (cmb,wdgType,lbl,""))
		If wdgType = "CMX" Then		' combo + text added
			txtProto.Initialize("txt")
			txtProto.Gravity = Bit.Or(Gravity.TOP, Gravity.Left)
			txtProto.TextSize = 12
			txtProto.Tag = field(1)
			widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lbl,cmb))
			fh_panel.Panel.AddView(txtProto,offsetX+5dip + dimLabels , offsetY+deltaY, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(Ceil(field(3)/wWidget)))
		End If
	Else If wdgType = "U" Then 
		Dim uLbl As Label
		uLbl.Initialize("")
		uLbl.text = field(4)
		widgetRef.Put(field(1),Array As Object (uLbl,wdgType,lbl,uLbl))
		fh_panel.Panel.AddView(uLbl,offsetX+5dip + dimLabels, offsetY+4dip, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(Ceil(field(3)/wWidget)))		
	Else
		txtProto.Initialize("txt")
		txtProto.Gravity = Bit.Or(Gravity.TOP, Gravity.Left)
		If wdgType = "P" Then txtProto.PasswordMode = True
		If wdgType = "DN" Or wdgType = "S" Or wdgType = "N" Then	' numerics fields
			txtProto.Gravity = Gravity.Right
			txtProto.InputType = txtProto.INPUT_TYPE_DECIMAL_NUMBERS
			If wdgType = "N" Then txtProto.InputType = txtProto.INPUT_TYPE_NUMBERS
		End If
		txtProto.TextSize = 12
		txtProto.Tag = field(1)
		txtProto.ForceDoneButton = True
		widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lbl,txtProto))
		If wdgType = "S" Then	' *** slide ***
			If Limits.get(field(1) & "Delta") < width*2.5 Then txtProto.Enabled = False
			Dim sldProto As SeekBar
			sldProto.Initialize("Slide")
			sldProto.Tag = field(1)	' widget name
			widgetRef.Put(field(1),Array As Object (sldProto,wdgType,lbl,txtProto))
			fh_panel.Panel.AddView(sldProto,offsetX+5dip + dimLabels, offsetY, width*3, deltaY*0.7)			
		else If wdgType = "QS" Then	' *** qualitative slide ***
			txtProto.Enabled = False
			Dim sldProto As SeekBar
			sldProto.Initialize("Slide")
			sldProto.Tag = field(1)	' widget name
			Private listSQ As List = splitKeyValue(field(1),field(5))
			Limits.Put(field(1),listSQ)
			sldProto.Max = listSQ.Size - 1
			widgetRef.Put(field(1),Array As Object (sldProto,wdgType,lbl,txtProto))
			fh_panel.Panel.AddView(sldProto,offsetX+5dip + dimLabels, offsetY, width*3, deltaY*0.7)			
		Else If wdgType = "CMT" Then		' *** ComboBox (spinner) with text
			cmb.Initialize("combos") 		'All combos share the same event sub
			cmb.TextSize = 12
			cmb.addall(splitKeyValue(field(1),field(5)))
			fh_panel.Panel.AddView(cmb,offsetX+5dip + dimLabels , deltaY + offsetY, field(3) * charWidth, deltaY-2dip)
			cmb.Tag = field(1)
			widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lbl,cmb))
		Else
			txtProto.HintColor = Colors.LightGray
			txtProto.Hint = field(5)
		End If
		If wdgType = "S" Or wdgType = "QS" Then
			fh_panel.Panel.AddView(txtProto,offsetX+8dip + dimLabels + width*3 , offsetY, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(1)-2)
		Else
			fh_panel.Panel.AddView(txtProto,offsetX+5dip + dimLabels , offsetY, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(Ceil(field(3)/wWidget)))
		End If
	End If
	If wdgType = "CMB" Then 
		typeForm = typeForm & "C"
	Else If wdgType = "B" Then 
		typeForm = typeForm & "B"
	Else
		typeForm = typeForm & "T"
	End If
	If wdgType <> "B"  And  wdgType <> "BC" Then	
		Dim pnlHeight As Int = getHeight(Ceil(field(3)/wWidget))
		If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
			pnlHeight = 0
		Else
			fh_panel.Panel.AddView(lbl,offsetX, 5dip+offsetY, width*2, width)
		End If
		If wdgType = "CMT" Then pnlHeight = 2*deltaY
		If wdgType = "CMX" Then pnlHeight = pnlHeight + deltaY
		offsetY = offsetY + pnlHeight
	End If
Next
' what buttons?
If typeForm <> "C" Then ' if no only one spinner
	btns = Regex.Split(",",finalButtons & "Cancel:" & standardButtons.Get("Cancel") & ",Reset:" & standardButtons.Get("Reset") & ",Ok:" & standardButtons.Get("Ok"))
	offsetBtn = offsetX +(100%x - offsetX*2 - btns.Length*(btnWidth)) * 0.5
	For i = 0 To btns.Length - 1
		btn.Initialize("buttons")
		btn.TextSize = 12
		Dim k() As String
		k = Regex.Split(":",btns(i))
		btn.text = k(1)
		btn.Tag = k(0)
		fh_panel.Panel.AddView(btn,offsetBtn +i*btnWidth,offsetY+6dip,btnWidth+10dip, deltaY-1dip)
		If btn.Tag = "Ok" Then widgetRef.Put(k(0),Array As Object (btn,"B"))	' lbl is fictious
		If btn.Tag <> "Ok" And  btn.Tag <> "Cancel" And  btn.Tag <> "Reset" Then
			widgetRef.Put(k(0),Array As Object (btn,getFromViewMap(btn.Tag,1),lbl,getFromViewMap(btn.Tag,3)))	' completed widgetRef key 
		End If
	Next
End If
If Sections.Length > 1 And fh_Data.Size > 0 Then
	setDefaults(False)
Else
	setDefaults(True)
End If
fh_panel.panel.Height = offsetY + deltaY + 4dip
act.AddView(fh_panel,0,0,100%x,100%y)
handleEvents(Array As Object ("fh_start","Start"))
End Sub
Private Sub setDefaults(reset As Boolean)	' true if is from reset button
	For i=0 To Defaults.Size - 1
		Dim key As String = Defaults.GetKeyAt(i)
		setValue(key,Defaults.GetValueAt(i))
		If Not((reset)) Then
			If fh_Data.ContainsKey(key) Then setValue(key,fh_Data.Get(key))	' data from another section
		End If
	Next
End Sub
Private Sub getHeight(rows As Int) As Int
	Return 18dip+rows*18dip	' font size 12 height = 18
End Sub
Private Sub deMask(data As String) As String
	Dim s  As String = data.Replace(Chr(1),",")
	Return s.Replace(Chr(2),";")
End Sub
Sub mask(data As String) As String	' mask comma AND semicolon
	Dim s As String = data.Replace(",",Chr(1))
	Return s.Replace(";",Chr(2))
End Sub
Sub Left(s As String,l As Int) As String
If l < s.Length Then Return s.SubString2(0,l)
Return s
End Sub
Sub Right(s As String,l As Int) As String
If l < s.Length Then Return s.SubString(s.Length-l)
Return s
End Sub
Sub iIF(Cond As Boolean,First As Object,Second As Object) As Object
	If Cond Then Return First
	Return Second
End Sub
Private Sub insertlistDir(dir As String) As List
	Dim lst As List
	lst.Initialize
	lst.AddAll(File.ListFiles(dir))
	lst.SortCaseInsensitive(True)
	If dir.indexOf2("/",1) > -1 Then lst.InsertAt(0,"..")
	Return lst
End Sub
Sub splitKeyValue(name As String,data As String) As List ' split key value (combos, qualitative sliders AND option buttons)
  Dim lst As List
  Dim dt(),key,value As String,k As Int 
  dt = Regex.Split("\|", data)
	lst.Initialize
	For j = 0 To dt.Length - 1
		If dt(j).IndexOf(":") < 0 Then dt(j)=dt(j) & ":" & dt(j)
		k = dt(j).IndexOf(":")
		key = dt(j).SubString2(0,k)
		value = dt(j).SubString(k+1)
		mapValues.Put(name & value,key)
		mapValues.Put(name & key,value)
		lst.add(value)
	Next
	Return lst
End Sub
Private Sub Buttons_Click		' *** exit routin
	Dim btn As Button = Sender
	handleEvents(Array As Object (btn.tag,"CLICK",btn))
'	fh_Data.Clear	' ****************************************************************
	If btn.Tag = "Reset" Then 
		setDefaults(True)
		handleEvents(Array As Object ("fh_reset","Reset"))
	Else If btn.Tag = "Cancel" Then
		fh_Data.Put("fh_button",btn.Tag)
		fh_panel.RemoveView
		CallSubDelayed2("","fh_answer",fh_Data)
	Else		
		If getFromViewMap(btn.Tag,1) = "BC" Then
			Dim	fh_CallBackSub() As String = Regex.Split("\.",getFromViewMap(btn.Tag,3))		' split module and sub
			If fh_CallBackSub.Length = 2 Then CallSubDelayed2(fh_CallBackSub(0),fh_CallBackSub(1),btn.Tag)
			Return
		End If
		If CheckErrors(btn) Then
			If fh_yesToExit Then				
				For i = 0 To hiddensMap.Size - 1' add hiddens fields
					fh_Data.Put(hiddensMap.GetKeyAt(i),hiddensMap.GetValueAt(i))
				Next
				handleEvents(Array As Object ("fh_end","End"))
				fh_panel.RemoveView
				CallSubDelayed2("","fh_answer",fh_Data)
			End If
		End If
	End If
End Sub
Private Sub CheckErrors(btnx As Button)	As Boolean	' for button end spinner aka button list
	Dim notError As Boolean = True
	Dim fieldError As Boolean
	Dim wdgtValue As String
	Dim wdgl As Label
	Private signal(1) As String
	signal(0) = ""
	For i = 0 To nElem -1
		fieldError = False
		field = Elem.GetValueAt(i)
		If field(0) = "B" Or field(0) = "BC" Then Continue
		Dim mandatory As Boolean = required.ContainsKey(field(1))
		wdgtValue = valueOf(field(1))
		wdgl = getFromViewMap(field(1),2)
		wdgl.TextColor = Colors.White
		If mandatory And wdgtValue = "" Then notError = Not(setError(wdgl,signal,"Required"))
		If checks.ContainsKey(field(1)) Then
			Private check As List = checks.Get(field(1))			
			For j = 0 To check.Size - 1
				Dim strCheck(2) As String =  check.Get(j)
				Matcher1 = Regex.Matcher2(".+\s*(=|<=|>=|<>|>|<|is)\s*(.*)",Regex.CASE_INSENSITIVE,strCheck(0))
				If Not(Matcher1.Find) Then Continue
				Dim operand As String = deMask(Matcher1.Group(2))
				Dim operator As String = Matcher1.Group(1)
				If operator.ToLowerCase <> "is" Then
					If Elem.ContainsKey(operand) Then operand = valueOf(operand)	' compare with field
					If Not(compare(numericTypes.GetDefault(field(0),False),valueOf(field(1)),operator,operand)) Then 
						fieldError = setError(wdgl,signal,strCheck(1))
					End If
				Else
					If operand.ToLowerCase() = "mail" Then 
						If Not(Regex.IsMatch("^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$|\s*",wdgtValue)) Then 
							fieldError = setError(wdgl,signal,strCheck(1))
						End If
					Else 		' my be a regular expression
						If Not(Regex.IsMatch(deMask(operand),wdgtValue)) Then fieldError = setError(wdgl,signal,strCheck(1))
					End If
				End If
				If fieldError Then notError = False
			Next
		End If
	Next
	If notError Then		
		fh_Data.Put("fh_button",btnx.Tag)
		For i=0 To nElem -1		' take data 
			field = Elem.GetvalueAt(i)
			fh_Data.Put(field(1),valueOf(field(1)))
		Next
	End If
	If signal(0) <> "" Then ToastMessageShow(signal(0),True)
	Return notError
End Sub
Sub compare(Numeric As Boolean,wdgtValue As String, operator As String, operand As String) As Boolean
	Dim cfr As Int = 1	' means equal
	If Numeric Then		' numeric field
		numericTypes.GetDefault(field(0),False)
		If wdgtValue = "" Then Return True			' no data - no compare
		If Not(IsNumber(operand)) Then Return True	' no data - no compare
		If wdgtValue > operand Then cfr = 2
		If wdgtValue < operand Then cfr = 4
	Else
		Dim cfr As Int = wdgtValue.CompareTo(operand)
		If cfr > 0 Then cfr = 2
		If cfr < 0 Then cfr = 4
		If cfr = 0 Then cfr = 1
	End If
	If Bit.And(cfr,comparator.Get(operator)) = 0 Then Return False
	Return True
End Sub
Sub setError(l As Label,signal() As String,s As String) As Boolean
	l.TextColor = Colors.Red
	If s <> "" Then signal(0) = signal(0) & Chr(10) & s
	Return True
End Sub
Private Sub handleEvents(parms() As Object) As Boolean
	If fh_handleSub.Length = 2 Then 
		CallSub2(fh_handleSub(0),fh_handleSub(1),parms)
	End If
End Sub
Private Sub Combos_ItemClick(Position As Int, Value As Object)
	Dim cb As Spinner = Sender
	Dim typeWidget As String = getViewType(cb.Tag)
	handleEvents(Array As Object (cb.Tag,"CLICK",cb,Value))
	If typeWidget = "F" Then
		Dim dir As String = getFromViewMap(cb.Tag,3)
		If cb.SelectedItem = ".." Then
			cb.Clear
			Dim fileInfo As Map = pathinfo(Value)
			Dim dir As String = fileInfo.Get("dirname")
			setInMap(cb.Tag,3,fileInfo.Get("dirname"))
			cb.AddAll(insertlistDir(getFromViewMap(cb.Tag,3)))
		Else
			If File.IsDirectory(dir, Value) = True Then
				cb.Clear
				cb.AddAll(insertlistDir(dir & "/" & Value))
				setInMap(cb.Tag,3,dir  & "/" & Value)
				cb.SelectedIndex = 0
			End If
		End If
		cb.Prompt = getFromViewMap(cb.Tag,3)
	Else If typeWidget = "CMT" Or typeWidget = "CMX" Then 
		setValue(cb.Tag,Value)
	Else If typeWidget = "CMB" And nElem = 1 Then		' only one spinner 
		handleEvents(Array As Object ("fh_end","End"))
		fh_Data.Put(field(1),valueOf(field(1)))
		fh_panel.RemoveView
		CallSubDelayed2(fh_returnSub(0),fh_returnSub(1),fh_Data)
	End If
End Sub
Private Sub RadioButton_CheckedChange(chk As Boolean)
	Dim rdb As RadioButton= Sender
	Dim a() As Object = widgetRef.get(rdb.Tag)
	a(3) = Sender
	widgetRef.Put(rdb.tag,a)
	handleEvents(Array As Object (rdb.tag,"CLICK",Sender,mapValues.get(rdb.Tag & rdb.text)))
End Sub
Private Sub txt_EnterPressed
	'txt = Sender
	'fh_module.handleEvents(Sender,Array As Object (txt.tag,"ENTER"))
End Sub
Sub txt_FocusChanged (HasFocus As Boolean)
	focusedText = Sender
	handleEvents(Array As Object (focusedText.tag,iIF(HasFocus,"FOCUS","LFOCUS"),Sender,focusedText.text))
	If HasFocus Then
		If getViewType(focusedText.Tag) = "T" Then startVoiceRec
		If tipsMap.ContainsKey(focusedText.Tag) Then ToastMessageShow(tipsMap.get(focusedText.Tag),True)
	End If
End Sub
Private Sub checkBox_CheckedChange(Checked As Boolean)
	Dim ckb As CheckBox = Sender
	handleEvents(Array As Object (ckb.tag,"CHK",Sender,iIF(Checked,1,0)))
End Sub
Private Sub Slide_ValueChanged (Value As Int, UserChanged As Boolean)
	Dim slideValue As Double,dec As Int,txtSlider As EditText
	Dim sld As SeekBar = Sender
	txtSlider = getFromViewMap(sld.Tag,3)
	If getFromViewMap(sld.Tag,1) = "QS" Then
		Private listQs As List = Limits.Get(sld.Tag)
		txtSlider.text = listQs.Get(Value)
		slideValue = Value
	Else
		If UserChanged Or txtSlider.Text <> "" Or Defaults.Get(sld.Tag) <> "" Then
			slideValue = Limits.get(sld.Tag & "Min") + Value * (Limits.get(sld.Tag & "Delta"))/100
			dec = Floor(Logarithm(Limits.get(sld.Tag & "Delta"),10))	' delta
			txtSlider.text = NumberFormat(slideValue,1,0)
			If dec < 3 Then txtSlider.text = NumberFormat(slideValue,1,-dec+2)
		End If
	End If
	handleEvents(Array As Object (sld.Tag,"SLIDE",sld,slideValue,getFromViewMap(sld.tag,3)))
End Sub
Sub toText(msk As String, values() As Object) As String
	Dim k,j=0 As Int
	Dim str As String
	Dim mtc As Matcher
	Dim strMatch As String = "%\d{0,2}\.\d|%\d{0,2}"	' accept % %n %nn %nn.n
	Dim editFormat() As String
	mtc = Regex.Matcher(strMatch,msk)
	Do While mtc.Find = True
    	k = msk.IndexOf(mtc.Match)
		If j < values.Length Then
			editFormat = Regex.Split("\.","0" & mtc.Match.SubString(1) & ".0.0")
			Select TypeOf(values(j))
				Case "Integer","Double"
					str = NumberFormat2(values(j),0,editFormat(1),editFormat(1),True)
					If editFormat(0) > 0 Then str = Right(fillString(editFormat(0)) & str,editFormat(0)) 
				Case Else
					str = values(j)
					If editFormat(0) > 0 Then str = Left(values(j) & fillString(editFormat(0)),editFormat(0))
			End Select
			msk = Left(msk,k) & str & msk.SubString(k+mtc.Match.Length)
		End If
		j = j+1
	Loop
	Return msk
End Sub
Sub TypeOf(obj As Object) As String
Dim t() As String = Regex.Split("\.",GetType(obj))
Return t(2)
End Sub
Private Sub fillString(n As Int) As String
'	Dim i As Int
	Dim str As String = ""
	For i=0 To n Step 10
		str = str & "          "
	Next
	Return Left(str,n)
End Sub
'Private Sub setSpinner(spin As Spinner,value As String)
'	spin.SelectedIndex = iIF(spin.IndexOf(value) > - 1,spin.IndexOf(value),0)
'End Sub
Private Sub setInMap(fld As String,pos As Int,val As Object)	' From field widget map parameters field, position
	Dim aWdg() As Object
	If Not(widgetRef.ContainsKey(fld)) Then Return 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then 
		aWdg(pos) = val
		widgetRef.Put(fld,aWdg)
	End If
End Sub
Sub pathinfo(dir As String) As Map
	Dim fInfo As Map = CreateMap("dirname":"","extension":"","filename":"","basename":"")
	Dim k As Int = dir.LastIndexOf("/")
	If k >= 0 Then 	fInfo.Put("dirname",Left(dir,k))
	Dim fl As String = dir.SubString(k+1)
	fInfo.Put("basename",fl)
	k = fl.LastIndexOf(".")
	fInfo.Put("filename",fl)
	If k >= 0 Then 
		fInfo.Put("filename",Left(fl,k))
		fInfo.Put("extension",fl.SubString(k+1))
	End If
	Return fInfo
End Sub
Sub startVoiceRec()
'	VR.Listen 'calls the voice recognition external activity
End Sub
Sub addCheck(sField As String,check() As String)
	Private a As List
	a.Initialize
	If checks.ContainsKey(sField) Then a = checks.Get(sField)
	a.add(check)
	checks.Put(sField,a)	
End Sub
Sub VR_Result (Success As Boolean, Texts As List)
	If Success = True Then
		Dim a() As Object = Array As Object(focusedText.tag,"VREND",focusedText,Texts.get(0))
		handleEvents(a)
		focusedText.text = iIF(focusedText.text = "",  a(3), focusedText.text & Chr(13) & Chr(10) &  a(3))
		startVoiceRec
	End If
End Sub
Sub enable(Name As String)
	SetWidget(Name,"Enable")
End Sub
Sub disable(Name As String)
	SetWidget(Name,"Disable")
End Sub
Sub SetWidget(Name As String,option As String)
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))	
	If aWdg.Length = 1 Then Return	' key exist?
	Dim v As View = aWdg(0)
	Dim opt As String = option.ToLowerCase
	Select opt
		Case "enable","disable"
			If TypeOf(v) = "Button" Or TypeOf(v) <> "BALayout" Then 
				v.Enabled = iIF(opt = "enable",True,False)
			Else
				pnl = aWdg(0)
				For i = 0 To pnl.NumberOfViews -1
					pnl.GetView(i).Enabled = iIF(opt = "enable",True,False)
				Next
			End If
		Case "visible","hidden"
			v.Visible = iIF(opt = "hidden",False,True)
	End Select
End Sub
Sub getHandle(Name As String) As Object
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))
	Return aWdg(0)
End Sub
Private Sub getFromViewMap(fld As String,pos As Int) As Object	' From field widget map parameters field, position
	Dim aWdg() As Object = widgetRef.GetDefault(fld,Array As Object(0))
	If aWdg.Length = 1 Then Return 0 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then Return aWdg(pos)
	Return 0
End Sub
Sub getViewType(Name As String) As String
	Return getFromViewMap(Name,1)
End Sub
Sub valueOf(Name As String) As String
	Dim a() As Object
	If widgetRef.ContainsKey(Name) Then
		a = widgetRef.get(Name)
		Select a(1)		' widget type
			Case "CMB","F"
				Dim cmb As Spinner = a(0)
				If a(1) = "CMB" Then Return mapValues.get(Name & cmb.SelectedItem)
				Return a(3) & "/" & iIF(cmb.SelectedItem = "..","",cmb.SelectedItem)
			Case "CKB"
				Dim chk As CheckBox = a(0)
				Return (iIF(chk.Checked,"1","0"))
			Case "S","QS"		' SeekBar
				Dim txt As EditText = a(3)
				If a(1) = "S" Then Return txt.text
				Return mapValues.get(Name & txt.text)
			Case "U"		' Unmodifiable
				Dim uLbl As Label = a(0)
				Return uLbl.text
			Case "R"		' RadioButton
				If a(3) = 0 Then Return ""
				Dim rdb As RadioButton = a(3)
				Return mapValues.get(Name & rdb.text)
			Case "B","BC"
				Return Name
			Case Else 		' text Views also CMT combo text
				Dim wdgT As EditText = a(0)
				Return wdgT.text
		End Select	
	End If
	Return ""
End Sub
Sub implode(sep As String,obj As List) As String
	Return implodeFrom(sep,obj,0,obj.Size)
End Sub
Sub implodeFrom(sep As String, obj As List,from As Int,To As Int) As String
	Dim implStr As String = ""
	For i = from To obj.size -1
	     implStr =  implStr & sep & obj.Get(i)
	Next
	If implStr.Length > 0 Then Return implStr.SubString(1)
	Return ""
End Sub
Sub setValue(Name As String,Value As String)
	Dim wdg As Object = iIF(widgetRef.ContainsKey(Name),getFromViewMap(Name,0),-1)
	If wdg = -1 Then Return	' no field
	Select getViewType(Name)
		Case "CMB"
			Dim cmb As Spinner = wdg
			cmb.SelectedIndex = iIF(cmb.IndexOf(Value) > - 1,cmb.IndexOf(Value),0)
'			setSpinner(cmb, Value)
		Case "CMT","CMX"
			Dim cmb As Spinner = getFromViewMap(Name,3)
			Dim txt As EditText = wdg
			If getViewType(Name) = "CMX" Then
				If Not(txt.Text.Contains(Value)) Then
					If txt.Text <> ""  Then  txt.Text =  txt.Text & Chr(10)
					txt.Text = txt.Text & Value
				End If
			Else
				txt.Text = Value	
			End If
			cmb.SelectedIndex = iIF(cmb.IndexOf(Value) > - 1,cmb.IndexOf(Value),0)		
'			setSpinner(cmb, Value)
		Case "F"
			Dim cmb As Spinner = wdg
			Dim fileInfo As Map = pathinfo(Value)
			Dim dir As String = fileInfo.Get("dirname")
			Dim fl As String = fileInfo.Get("basename")
			If dir = "" Then dir = File.DirRootExternal
			cmb.Clear
			cmb.addall(insertlistDir(dir))
			cmb.Prompt = dir
			setInMap(Name,3,dir)
			cmb.SelectedIndex = cmb.IndexOf(fl)
		Case "S"
			Dim sld As SeekBar = wdg
			If IsNumber(Value) Then 
				sld.Value = (Value - Limits.get(sld.Tag & "Min"))*100/(Limits.get(sld.Tag & "Max") - Limits.get(sld.Tag & "Min"))
			Else
				Dim txt As EditText = getFromViewMap(sld.Tag,3)
				sld.Value = 0	' Limits.Get(Name & "Min")	' set un
				txt.Text = ""
			End If
		Case "QS"
			Dim sld As SeekBar = wdg
			Dim txt As EditText = getFromViewMap(sld.Tag,3)
			Private listQs As List = Limits.Get(Name)
			listQs.IndexOf(Value)
			sld.Value = listQs.IndexOf(Value)
		Case "T","N","DN","P"
			Dim txt As EditText = wdg
			txt.text = Value
		Case "CKB"
			Dim chk As CheckBox = wdg
			chk.Checked = iIF(Left(Value,5).ToLowerCase = "check" Or Value = "1", True,False)
		Case "U" 
			Dim uLbl As Label = wdg
			uLbl.text = Value
		Case "R"
			pnl = getFromViewMap(Name,0)
			Dim v As View
			setInMap(Name,3,0)
			For i = 0 To pnl.NumberOfViews -1
				v = pnl.GetView(i)
				If TypeOf(v) = "RadioButton" Then
					Dim rdb As RadioButton = pnl.GetView(i)
					rdb.Checked = False
					If rdb.text = Value Or rdb.text = mapValues.GetDefault(Name & Value,"") Then 
						rdb.Checked = True
						setInMap(Name,3,rdb)
					End If
				End If
			Next
		Case "B","BC"
			Dim btn As Button = wdg
			btn.Enabled = iIF(Left(Value,3).ToLowerCase = "dis",False,True)
	End Select
End Sub
Sub decodeColor(C As String) As Int
Dim Match As Matcher = Regex.Matcher("[\daAbBcCdDeEfF]{8}", C)	' eight exadecimals digit
If Not(Match.Find) Then Return -16777216 	' opaque black
If (C.SubString2(0,1)).compareto("7") > 0 Then
	Return - Power(2,31) + Bit.ParseInt("01234567".CharAt(Bit.ParseInt(C.SubString2(0,1),16)-8) & C.SubString(1),16)
End If
Return Bit.ParseInt(C,16)
End Sub
Sub Dialog(activ As Activity,title As String,Default As String) As String
	pnl.Initialize("pnl")
	Dim c As ColorDrawable
	pnl.Color = Colors.ARGB(127,127,127,127)
	InputBox.Initialize("InputBox")
	InputBox.Text = Default
	InputBox.ForceDoneButton = True
	lbl.Initialize("")
	lbl.TextSize = 18
	c.Initialize2(Colors.Gray,5dip,1dip,Colors.DarkGray)
	lbl.Background = c	
	lbl.TextColor = Colors.RGB(0,0,127)
	lbl.Gravity = Bit.Or(Gravity.TOP, Gravity.CENTER)
	lbl.Text = title
	pnl.AddView(lbl,10%x,36%y,80%x,28%y)
	pnl.AddView(InputBox,11%x,43%y,79%x,10%y)
	addButton("Ok","OkCancel",30%x)
	addButton("Cancel","OkCancel",50%x)
	activ.AddView(pnl,0%x,0%x,100%x,100%y)
	fh_yesToExit = False
	InputBox.RequestFocus
	Do While Not(fh_yesToExit)
		DoEvents
	Loop
	Dim s As String = InputBox.text
    For i = 0 To act.NumberOfViews - 1
        If activ.GetView(i) = pnl Then
            activ.RemoveViewAt(i)
            Exit
        End If
    Next
	Return s.Replace(Chr(10),"")
End Sub
Sub addButton(Caption As String,Name As String,x As Int)
	btn.initialize(Name)
	btn.TextSize = 10
	btn.Text = Caption
	pnl.AddView(btn,x,54%y,60dip,40dip)
End Sub
Sub InputBox_EnterPressed
	fh_yesToExit = True
End Sub
Sub OkCancel_Click
	Dim btn As Button = Sender
	If btn.Text <> "Ok" Then InputBox.Text = ""
	fh_yesToExit = True	
End Sub
Sub pnl_Click
	' consume panel events
End Sub